<?
# $Author: zx $
# $Date: 2003/07/29 20:37:54 $

#  Modified IP address logging information to hold both proxy and actual IP
#  by Zhen-Xjell @ nukecops.com

# ******************************************************************************
#   PHPnuke Tracking v2.0 13 May 2003
#
#   for PHPnuke 6.5
#
#   Copyright (C) 2003 by Nuke Cops http://nukecops.com
#   Zhen-Xjell
#
#   Copyright (C) 2002 by WebStyle http://www.wstyle.org
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# ******************************************************************************
#
# *****************************************************************************
# Please modify here your exclude IPs / URL / SERVERNAME
# *****************************************************************************
$hf_debug      = '0';     # default 0 / Debug information  1=YES  /  0=NO
$hf_exclude    = '0';     # default 0 / Stop Tracking?     1=YES  /  0=NO
$track_cookie  = '1';     # default 1 / use cookies to identify users?   1=YES  /  0=NO

# Exclude IPs
$exclude_ip  = array("");
  
# Exclude nuke usernames
$exclude_user  = array(
  "Zhen-Xjell",
  "");

# Exclude url containing strings
$exclude_url  = array(
  "/admin.php?op=trackingshow");
  
# *****************************************************************************
# Here starts the update, normaly no changes neccessarry
# *****************************************************************************

function start_trackhack() {

  global $hf_debug, $hf_exclude, $track_cookie, $exclude_ip, $exclude_user, $exclude_url;

  if (!isset($prefix)) { global $prefix; }
  if (!isset($user))  { global $user; }
  if ($user=='') {
    $user_id = '';
  } else {
    $userinfo = getusrinfo($user);
    $user_id = $userinfo[user_id];
    $username = $userinfo[username];
  }
  if ($hf_debug=='1') { echo "here is trackhack.php for user_id=".$user_id." username=".$userinfo[username]."<br>"; }
  
  if ($track_cookie==1) {
    if ($hf_debug=='1') { echo "we are working with cookies<br>"; }

    if (!isset($HTTP_COOKIE_VARS))  { global $HTTP_COOKIE_VARS; }

    if ( !isset($HTTP_COOKIE_VARS["anno"]) ) {
      $trackid       = date("ymdHis", time() );
      $cookie_encode = base64_encode ($trackid.":".$user_id );
      setcookie("anno","$cookie_encode",time()+ 3600 * 24 * 7 * 52);
      if ($hf_debug=='1') { echo "No cookie anno found. I've set one with trackid=".$trackid." and user_id=".$user_id."<br>"; }
    } else {
      $anno = base64_decode($HTTP_COOKIE_VARS["anno"] );
      $track_cookie = explode(":", $anno);

      $trackid    = $track_cookie[0];
      $track_user_id  = $track_cookie[1];
      if ($hf_debug=='1') { echo "cookie anno found with trackid=".$trackid." track_user_id=".$track_user_id."<br>"; }

      if ( $track_cookie[0] == '' ) {
        $trackid       = date("ymdHis", time() );
        $cookie_encode = base64_encode ($trackid.":".$user_id );
        setcookie("anno","$cookie_encode",time()+ 3600 * 24 * 7 * 52);
        if ($hf_debug=='1') { echo "Trackid in cookie was empthy. Create new one with trackid=".$trackid." and user_id=".$user_id."<br>"; }
      }

      if ( ($user_id != '') and ($track_cookie[1]!=$user_id ) ) {
        $cookie_encode = base64_encode ($track_cookie[1].":".$user_id);
        setcookie("anno","$cookie_encode",time()+ 3600 * 24 * 7 * 52);
        if ($hf_debug=='1') { echo "Uid in cookie was different. Create new one with trackid=".$trackid." and user_id=".$user_id."<br>"; }
      }
    }
  }

  if (getenv("PATH_INFO")!='') {
    if (getenv("QUERY_STRING")!='') {
      $requri = getenv("PATH_INFO")."?".getenv("QUERY_STRING");
      if ($hf_debug=='1') { echo "i use from PATH_INFO requri=".$requri."<br>"; }
    }
    else {
      $requri = getenv("PATH_INFO");
      if ($hf_debug=='1') { echo "i use from PATH_INFO requri=".$requri."<br>"; }
    }
  } else {
   $requri = getenv("REQUEST_URI");
   if ($hf_debug=='1') { echo "i use from REQUEST_URI requri=".$requri."<br>"; }
  }

#  $remote_addr = getenv("REMOTE_ADDR");

  if (getenv("HTTP_X_FORWARDED_FOR")){
    $remote_addr = getenv("HTTP_X_FORWARDED_FOR");
  } else {
    $remote_addr = getenv("REMOTE_ADDR");
  }

  $server      = getenv("SERVER_NAME");
  $referer     = getenv("HTTP_REFERER");
  $tracktime   = date("Y-m-d H:i:s", time());

  while(list($key,$value) = each($exclude_ip)) {
    if ($remote_addr==$value) { 
      if ($hf_debug=='1') { echo "exclude from tracking remote_addr=".$remote_addr."<br>"; }
      $hf_exclude="1"; 
    }
  }
  while(list($key,$value) = each($exclude_user)) {
    if ($username==$value) { 
      if ($hf_debug=='1') { echo "exclude from tracking username=".$username."<br>"; }
      $hf_exclude="1";
    }
  }
  while(list($key,$value) = each($exclude_url)) {
    if (stristr($requri,$value)) {
      if ($hf_debug=='1') { echo "exclude from tracking requri=".$requri."<br>"; }
      $hf_exclude="1";
    }
  }

  if ($hf_exclude!='1') {
    switch ($requri) {
      case ( "/" ):
        $requri = "/index.php";
        break;
      case ( "/index.php3" ):
        $requri = "/index.php";
        break;
    }

    mysql_query("insert into $prefix"._tracking.
                  " values ('$tracktime', '$remote_addr', '$user_id', '$server', '$referer', '$requri', '$trackid') ");

    if ($hf_debug=='1') { 
      echo "tracking write to database, affected rows:".mysql_affected_rows()." Errno:".mysql_errno()." Errortext:".mysql_error()."<br>";
      echo "values tracktime=".$tracktime.
            " remote_addr=".$remote_addr.
            " user_id=".$user_id.
            " server=".$server.
            " referer=".$referer.
            " requri=".$requri.
            " trackid=".$trackid.
            "<br>"; 
    }
  }
}

start_trackhack();

# $log$

?>
