<?php
/***************************************************************************
 *                              board_message_xl.php
 *                            -------------------
 *   begin                : June 26, 2002
 *   copyright            : (C) 2002 Shannado
 *   email                : sven@shannado.nl
 *
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

include('includes/functions_bm.'.$phpEx);
include_once('includes/bbcode.'.$phpEx);

$bm_id = '';
$bm_title = $lang['Bm_error'];
$bm_msg = $lang['Bm_no_message'];
$bm_width = '50%';
$bm_images = '';

$bm_prv_id = '';
$bm_prv_title = '';
$bm_nxt_id = '';
$bm_nxt_title = '';
$l_bm_nxt='';
$l_bm_prv='';


$sql = get_boardmsg_sql($userdata['bm_page'], $userdata['user_timezone']);
$sql_pn = $sql;

if  ( isset($HTTP_GET_VARS['bm']) )
{
	$bm_id = $HTTP_GET_VARS['bm'];
	$sql .= " AND msg_id = '" . $bm_id . "'";
}
$sql .= " ORDER BY ordr ASC, msg_id ASC";

if ( $result = $db->sql_query($sql) )
{
	if ( $row = $db->sql_fetchrow($result) )
	{
		$bm_ordr = $row['ordr'];
		$bm_id = $row['msg_id'];
		if ( $userdata['user_level'] == ADMIN )
		{
			$bm_title = '<a href= "' . $phpbb_root_path . 'admin/admin_board_msg_xl.' . $phpEx . '?mode=edit&id=' . $bm_id . '">' . $row['title'] . '</a>';
		}
		else
		{
			$bm_title = $row['title'];
		}
		$bm_msg = $row['message'];
		$bm_width = $row['width'] . "%";
		
		if ( $row['images'] != '' )
		{
			$bm_images = '<img src= "' . $phpbb_root_path . $row['images'] . '" border="0"/>';
		}
		$bbcode_uid = $row['bbcode_uid'];
		if ( $bbcode_uid != '' )
		{
			$bm_msg = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($bm_msg, $bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $bm_msg);
		}
		$bm_msg = smilies_pass($bm_msg);
		$bm_msg = make_clickable($bm_msg);
	}
}

$bm_page_php = get_bm_page_php($userdata['bm_page']);

$sql_prv = $sql_pn;
$sql_prv .= " AND ordr < " . $bm_ordr . "
		ORDER BY ordr DESC, msg_id ASC 
		LIMIT 1";

if ( $result = $db->sql_query($sql_prv) )
{

	if ( $row = $db->sql_fetchrow($result) )
	{
		$bm_prv_id = $row['msg_id'];
		$bm_prv_title = $row['title'];
		$l_bm_prv = $lang['Bm_prev'];
	}	
}

$sql_nxt = $sql_pn;
$sql_nxt .= " AND ordr > " . $bm_ordr . "
		ORDER BY ordr ASC, msg_id ASC 
		LIMIT 1";

if ( $result = $db->sql_query($sql_nxt) )
{
	if ( $row = $db->sql_fetchrow($result) )
	{
		$bm_nxt_id = $row['msg_id'];
		$bm_nxt_title = $row['title'];
		$l_bm_nxt = $lang['Bm_next'];
	}	
}


$template->assign_vars(array(
	'BM_TITLE' => $bm_title,
	'BM_MSG' => $bm_msg,
	'BM_WIDTH' => $bm_width,
	'BM_IMAGES' => $bm_images,
	'BM_PRV_TITLE' => $bm_prv_title,
	'U_BM_PRV' => append_sid($bm_page_php . 'bm=' . $bm_prv_id), 
	'BM_NXT_TITLE' => $bm_nxt_title,
	'U_BM_NXT' => append_sid($bm_page_php . 'bm=' . $bm_nxt_id), 
	'L_BM_NXT' => $l_bm_nxt,
	'L_BM_PRV' => $l_bm_prv)
);


if ($bm_id != '')
{
	$template->assign_block_vars('switch_board_msg', array()); 
}

